"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isIterableConstructor = exports.isIterable = exports.isMap = exports.isSet = void 0;
function isSet(obj) {
    return Object.prototype.toString.call(obj) === '[object Set]';
}
exports.isSet = isSet;
function isMap(obj) {
    return Object.prototype.toString.call(obj) === '[object Map]';
}
exports.isMap = isMap;
function isIterable(obj) {
    if (obj == null) {
        return false;
    }
    return obj[Symbol.iterator] !== undefined;
}
exports.isIterable = isIterable;
function isIterableConstructor(obj) {
    if (obj == null || obj.prototype == null) {
        return false;
    }
    return obj.prototype[Symbol.iterator] !== undefined;
}
exports.isIterableConstructor = isIterableConstructor;
