"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadContext = void 0;
var mappingError_1 = require("./mappingError");
var ReadContext = (function () {
    function ReadContext(session) {
        this.session = session;
        this.path = "";
    }
    ReadContext.prototype.addError = function (message, path) {
        if (!this.errors) {
            this.errors = [];
            this.hasErrors = true;
        }
        this.errors.push({
            message: message,
            path: path || this.path
        });
    };
    ReadContext.prototype.addFetch = function (path) {
        if (!this.fetches) {
            this.fetches = [];
        }
        this.fetches.push(path);
    };
    ReadContext.prototype.getErrorMessage = function () {
        return (0, mappingError_1.createErrorMessage)(this.errors);
    };
    return ReadContext;
}());
exports.ReadContext = ReadContext;
